#include <pw/core/vector.hpp>
#include <pw/core/quaternion.hpp>

#include <string>

namespace pw {

class component {

    std::string _name;

    //! only very few components can be attached multiple times
    virtual bool singular() const { return true; }
};

class transform : public component {

    matrix44d _local;
    matrix44d _global;

};

class trs : public transform {

    vector3d _position;
    vector3d _scale;
    quaterniond _rotation;
};

}
